function calc(arg1)
	if arg1=="" then 
		Calc_OpenFrame()
	else
		local x,y=string.find(arg1,"%p?%d*%p?%d*")
		num1 = string.sub(arg1,x,y)
		local h,k=string.find(arg1,"%a*",y+2)
		fun  = string.sub(arg1,h,k)
		local a,z=string.find(arg1,"%p?%d*%p?%d*",k+2)
		num2 = string.sub(arg1,a,z)

		if fun=="plus" then print(num1.." + "..num2.." = "..tonumber(num1)+tonumber(num2)) CalcText = tonumber(num1)+tonumber(num2)
		elseif fun=="minus" then print(num1.." - "..num2.." = "..tonumber(num1)-tonumber(num2)) CalcText = tonumber(num1)-tonumber(num2)
		elseif fun=="times" or fun=="*" then print(num1.." x "..num2.." = "..tonumber(num1)*tonumber(num2)) CalcText = tonumber(num1)*tonumber(num2)
		elseif fun=="divided by" or fun=="divide" then print(num1.." / "..num2.." = "..tonumber(num1)/tonumber(num2)) CalcText = tonumber(num1)/tonumber(num2)
		elseif fun=="caret" or fun=="power" then print(num1.." ^ "..num2.." = "..tonumber(num1)^tonumber(num2)) CalcText = tonumber(num1)^tonumber(num2)
		elseif fun=="root"then print(num2.."th root of "..num1.." = "..tonumber(num1)^(1/tonumber(num2))) CalcText = tonumber(num1)^(1/tonumber(num2))
		end
	end
end

function Calc_OpenFrame()
	if Windowshown==nil then 
		Windowshown="true"

		CalcMainWindow = CreateFrame("Frame",nil,UIParent)
		CalcMainWindow:SetWidth(180)
		CalcMainWindow:SetHeight(230)
		CalcMainWindow:SetPoint("CENTER",UIParent,"CENTER",140,75)
		CalcMainWindow:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		CalcMainWindow:EnableMouse(true)
		CalcMainWindow:SetMovable(true)
		CalcMainWindow:SetScript("OnMouseDown",function() CalcMainWindow:StartMoving() end)
		CalcMainWindow:SetScript("OnMouseUp",function() CalcMainWindow:StopMovingOrSizing() end)
		CalcMainWindow:SetFrameLevel(1)

		CalcMainWindowText = CalcMainWindow:CreateFontString(nil,nil,"GameFontHighlight")
		CalcMainWindowText:SetPoint("TOPLEFT",CalcMainWindow,"TOPLEFT",7,-7)
		CalcMainWindowText:SetTextColor(1,1,0)
		CalcMainWindowText:SetText("Calculator")

		CalcCloseButton = CreateFrame("Button",nil,CalcMainWindow)
		CalcCloseButton:SetWidth(20)
		CalcCloseButton:SetHeight(20)
		CalcCloseButton:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
		CalcCloseButton:SetBackdropColor(1,0,0)
		CalcCloseButton:SetPoint("TOPRIGHT",CalcMainWindow,"TOPRIGHT",-7,-7)
		CalcCloseButton:EnableMouse(true)
		CalcCloseButton:SetScript("OnMouseDown",function() if GetMouseButtonClicked()=="RightButton" then CalcCloseButton:SetBackdropColor(0,0,0) end end)
		CalcCloseButton:SetScript("OnMouseUp",function() CalcMainWindow:Hide() CalcEditBox:SetText("") end)
		CalcCloseButton:SetFrameLevel(2)

		CalcEditBox = CreateFrame("EditBox","CalcEditBox",CalcMainWindow,"InputBoxTemplate")
		CalcEditBox:SetHeight(100)
		CalcEditBox:SetWidth(100)
		CalcEditBox:SetPoint("TOP",CalcMainWindow,"TOP",0,0)
		CalcEditBox:SetAutoFocus(false)
		CalcEditBox:SetJustifyH("RIGHT")
		CalcEditBox:SetTextInsets(2,2,0,0)
		CalcEditBox:SetScript("OnEnterPressed",function() calc(CalcEditBox:GetText()) CalcEditBox:SetText(CalcText) end)
	elseif Windowshown=="true" then 
		CalcMainWindow:Hide()
		Windowshown="false"
	elseif Windowshown=="false" then 
		CalcMainWindow:Show() 
		CalcCloseButton:SetBackdropColor(1,0,0)
		Windowshown="true"
	end
Calculator_Buttons()
end

function Calculator_Buttons()
	zero = CreateFrame("Frame",nil,CalcMainWindow)
	zero:SetHeight(25)
	zero:SetWidth(25)
	zero:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	zero:SetBackdropColor(1,1,1)
	zerotext = zero:CreateFontString(nil,nil,"GameFontHighlightLarge")
	zerotext:SetTextColor(0,0,1)
	zerotext:SetText("0")
	zerotext:SetPoint("CENTER",zero,"CENTER")
	zero:EnableMouse(true)
	zero:SetPoint("BOTTOMLEFT",CalcMainWindow,"BOTTOMLEFT",20,20)
	zero:SetScript("OnMouseUp",function() zero:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."0" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	zero:SetScript("OnEnter",function() zero:SetBackdropColor(1,1,0) end)
	zero:SetScript("OnLeave",function() zero:SetBackdropColor(1,1,1) end)
	zero:SetScript("OnMouseDown",function() zero:SetBackdropColor(0,0,0) end)

	one = CreateFrame("Frame",nil,CalcMainWindow)
	one:SetHeight(25)
	one:SetWidth(25)
	one:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	one:SetBackdropColor(1,1,1)
	onetext = one:CreateFontString(nil,nil,"GameFontHighlightLarge")
	onetext:SetTextColor(0,0,1)
	onetext:SetText("1")
	onetext:SetPoint("CENTER",one,"CENTER")
	one:EnableMouse(true)
	one:SetPoint("BOTTOMLEFT",zero,"TOPLEFT",0,5)
	one:SetScript("OnMouseUp",function() one:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."1" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	one:SetScript("OnEnter",function() one:SetBackdropColor(1,1,0) end)
	one:SetScript("OnLeave",function() one:SetBackdropColor(1,1,1) end)
	one:SetScript("OnMouseDown",function() one:SetBackdropColor(0,0,0) end)

	two = CreateFrame("Frame",nil,CalcMainWindow)
	two:SetHeight(25)
	two:SetWidth(25)
	two:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	two:SetBackdropColor(1,1,1)
	twotext = two:CreateFontString(nil,nil,"GameFontHighlightLarge")
	twotext:SetTextColor(0,0,1)
	twotext:SetText("2")
	twotext:SetPoint("CENTER",two,"CENTER")
	two:EnableMouse(true)
	two:SetPoint("LEFT",one,"RIGHT",5,0)
	two:SetScript("OnMouseUp",function() two:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."2" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	two:SetScript("OnEnter",function() two:SetBackdropColor(1,1,0) end)
	two:SetScript("OnLeave",function() two:SetBackdropColor(1,1,1) end)
	two:SetScript("OnMouseDown",function() two:SetBackdropColor(0,0,0) end)

	three = CreateFrame("Frame",nil,CalcMainWindow)
	three:SetHeight(25)
	three:SetWidth(25)
	three:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	three:SetBackdropColor(1,1,1)
	threetext = three:CreateFontString(nil,nil,"GameFontHighlightLarge")
	threetext:SetTextColor(0,0,1)
	threetext:SetText("3")
	threetext:SetPoint("CENTER",three,"CENTER")
	three:EnableMouse(true)
	three:SetPoint("LEFT",two,"RIGHT",5,0)
	three:SetScript("OnMouseUp",function() three:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."3" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	three:SetScript("OnEnter",function() three:SetBackdropColor(1,1,0) end)
	three:SetScript("OnLeave",function() three:SetBackdropColor(1,1,1) end)
	three:SetScript("OnMouseDown",function() three:SetBackdropColor(0,0,0) end)

	four = CreateFrame("Frame",nil,CalcMainWindow)
	four:SetHeight(25)
	four:SetWidth(25)
	four:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	four:SetBackdropColor(1,1,1)
	fourtext = four:CreateFontString(nil,nil,"GameFontHighlightLarge")
	fourtext:SetTextColor(0,0,1)
	fourtext:SetText("4")
	fourtext:SetPoint("CENTER",four,"CENTER")
	four:EnableMouse(true)
	four:SetPoint("BOTTOM",one,"TOP",0,5)
	four:SetScript("OnMouseUp",function()four:SetBackdropColor(1,1,1)  CalcText = CalcEditBox:GetText().."4" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	four:SetScript("OnEnter",function() four:SetBackdropColor(1,1,0) end)
	four:SetScript("OnLeave",function() four:SetBackdropColor(1,1,1) end)
	four:SetScript("OnMouseDown",function() four:SetBackdropColor(0,0,0) end)

	five = CreateFrame("Frame",nil,CalcMainWindow)
	five:SetHeight(25)
	five:SetWidth(25)
	five:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	five:SetBackdropColor(1,1,1)
	fivetext = five:CreateFontString(nil,nil,"GameFontHighlightLarge")
	fivetext:SetTextColor(0,0,1)
	fivetext:SetText("5")
	fivetext:SetPoint("CENTER",five,"CENTER")
	five:EnableMouse(true)
	five:SetPoint("LEFT",four,"RIGHT",5,0)
	five:SetScript("OnMouseUp",function() five:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."5" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	five:SetScript("OnEnter",function() five:SetBackdropColor(1,1,0) end)
	five:SetScript("OnLeave",function() five:SetBackdropColor(1,1,1) end)
	five:SetScript("OnMouseDown",function() five:SetBackdropColor(0,0,0) end)

	six = CreateFrame("Frame",nil,CalcMainWindow)
	six:SetHeight(25)
	six:SetWidth(25)
	six:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	six:SetBackdropColor(1,1,1)
	sixtext = six:CreateFontString(nil,nil,"GameFontHighlightLarge")
	sixtext:SetTextColor(0,0,1)
	sixtext:SetText("6")
	sixtext:SetPoint("CENTER",six,"CENTER")
	six:EnableMouse(true)
	six:SetPoint("LEFT",five,"RIGHT",5,0)
	six:SetScript("OnMouseUp",function() six:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."6" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	six:SetScript("OnEnter",function() six:SetBackdropColor(1,1,0) end)
	six:SetScript("OnLeave",function() six:SetBackdropColor(1,1,1) end)
	six:SetScript("OnMouseDown",function() six:SetBackdropColor(0,0,0) end)

	seven = CreateFrame("Frame",nil,CalcMainWindow)
	seven:SetHeight(25)
	seven:SetWidth(25)
	seven:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	seven:SetBackdropColor(1,1,1)
	seventext = seven:CreateFontString(nil,nil,"GameFontHighlightLarge")
	seventext:SetTextColor(0,0,1)
	seventext:SetText("7")
	seventext:SetPoint("CENTER",seven,"CENTER")
	seven:EnableMouse(true)
	seven:SetPoint("BOTTOM",four,"TOP",0,5)
	seven:SetScript("OnMouseUp",function() seven:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."7" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	seven:SetScript("OnEnter",function() seven:SetBackdropColor(1,1,0) end)
	seven:SetScript("OnLeave",function() seven:SetBackdropColor(1,1,1) end)
	seven:SetScript("OnMouseDown",function() seven:SetBackdropColor(0,0,0) end)

	eight = CreateFrame("Frame",nil,CalcMainWindow)
	eight:SetHeight(25)
	eight:SetWidth(25)
	eight:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	eight:SetBackdropColor(1,1,1)
	eighttext = eight:CreateFontString(nil,nil,"GameFontHighlightLarge")
	eighttext:SetTextColor(0,0,1)
	eighttext:SetText("8")
	eighttext:SetPoint("CENTER",eight,"CENTER")
	eight:EnableMouse(true)
	eight:SetPoint("LEFT",seven,"RIGHT",5,0)
	eight:SetScript("OnMouseUp",function() eight:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."8" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	eight:SetScript("OnEnter",function() eight:SetBackdropColor(1,1,0) end)
	eight:SetScript("OnLeave",function() eight:SetBackdropColor(1,1,1) end)
	eight:SetScript("OnMouseDown",function() eight:SetBackdropColor(0,0,0) end)

	nine = CreateFrame("Frame",nil,CalcMainWindow)
	nine:SetHeight(25)
	nine:SetWidth(25)
	nine:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	nine:SetBackdropColor(1,1,1)
	ninetext = nine:CreateFontString(nil,nil,"GameFontHighlightLarge")
	ninetext:SetTextColor(0,0,1)
	ninetext:SetText("9")
	ninetext:SetPoint("CENTER",nine,"CENTER")
	nine:EnableMouse(true)
	nine:SetPoint("LEFT",eight,"RIGHT",5,0)
	nine:SetScript("OnMouseUp",function() nine:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().."9" CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	nine:SetScript("OnEnter",function() nine:SetBackdropColor(1,1,0) end)
	nine:SetScript("OnLeave",function() nine:SetBackdropColor(1,1,1) end)
	nine:SetScript("OnMouseDown",function() nine:SetBackdropColor(0,0,0) end)

	sign = CreateFrame("Frame",nil,CalcMainWindow)
	sign:SetHeight(25)
	sign:SetWidth(25)
	sign:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	sign:SetBackdropColor(1,1,1)
	signtext = sign:CreateFontString(nil,nil,"GameFontHighlightLarge")
	signtext:SetTextColor(0,0,1)
	signtext:SetText("+/-")
	signtext:SetPoint("CENTER",sign,"CENTER")
	sign:EnableMouse(true)
	sign:SetPoint("LEFT",zero,"RIGHT",5,0)
	sign:SetScript("OnMouseUp",function() sign:SetBackdropColor(1,1,1) local teststring = string.sub(CalcEditBox:GetText(),1,1) if teststring=="-" then CalcText = string.sub(CalcEditBox:GetText(),2) CalcEditBox:SetText(CalcText) else CalcText = "-"..CalcEditBox:GetText() CalcEditBox:SetText(CalcText) end end)
	sign:SetScript("OnEnter",function() sign:SetBackdropColor(1,1,0) end)
	sign:SetScript("OnLeave",function() sign:SetBackdropColor(1,1,1) end)
	sign:SetScript("OnMouseDown",function() sign:SetBackdropColor(0,0,0) end)

	point = CreateFrame("Frame",nil,CalcMainWindow)
	point:SetHeight(25)
	point:SetWidth(25)
	point:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	point:SetBackdropColor(1,1,1)
	pointtext = point:CreateFontString(nil,nil,"GameFontHighlightLarge")
	pointtext:SetTextColor(0,0,1)
	pointtext:SetText(".")
	pointtext:SetPoint("CENTER",point,"CENTER")
	point:EnableMouse(true)
	point:SetPoint("LEFT",sign,"RIGHT",5,0)
	point:SetScript("OnMouseUp",function() point:SetBackdropColor(1,1,1) CalcEditBox:SetText(CalcEditBox:GetText()..".") end)
	point:SetScript("OnEnter",function() point:SetBackdropColor(1,1,0) end)
	point:SetScript("OnLeave",function() point:SetBackdropColor(1,1,1) end)
	point:SetScript("OnMouseDown",function() point:SetBackdropColor(0,0,0) end)

	plus = CreateFrame("Frame",nil,CalcMainWindow)
	plus:SetHeight(25)
	plus:SetWidth(25)
	plus:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	plus:SetBackdropColor(1,1,1)
	plustext = plus:CreateFontString(nil,nil,"GameFontHighlightLarge")
	plustext:SetTextColor(0,0,1)
	plustext:SetText("+")
	plustext:SetPoint("CENTER",plus,"CENTER")
	plus:EnableMouse(true)
	plus:SetPoint("LEFT",point,"RIGHT",5,0)
	plus:SetScript("OnMouseUp",function() plus:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." plus " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	plus:SetScript("OnEnter",function() plus:SetBackdropColor(1,1,0) end)
	plus:SetScript("OnLeave",function() plus:SetBackdropColor(1,1,1) end)
	plus:SetScript("OnMouseDown",function() plus:SetBackdropColor(0,0,0) end)

	minus = CreateFrame("Frame",nil,CalcMainWindow)
	minus:SetHeight(25)
	minus:SetWidth(25)
	minus:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	minus:SetBackdropColor(1,1,1)
	minustext = minus:CreateFontString(nil,nil,"GameFontHighlightLarge")
	minustext:SetTextColor(0,0,1)
	minustext:SetText("-")
	minustext:SetPoint("CENTER",minus,"CENTER")
	minus:EnableMouse(true)
	minus:SetPoint("BOTTOM",plus,"TOP",0,5)
	minus:SetScript("OnMouseUp",function() minus:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." minus " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	minus:SetScript("OnEnter",function() minus:SetBackdropColor(1,1,0) end)
	minus:SetScript("OnLeave",function() minus:SetBackdropColor(1,1,1) end)
	minus:SetScript("OnMouseDown",function() minus:SetBackdropColor(0,0,0) end)

	times = CreateFrame("Frame",nil,CalcMainWindow)
	times:SetHeight(25)
	times:SetWidth(25)
	times:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	times:SetBackdropColor(1,1,1)
	timestext = times:CreateFontString(nil,nil,"GameFontHighlightLarge")
	timestext:SetTextColor(0,0,1)
	timestext:SetText("*")
	timestext:SetPoint("CENTER",times,"CENTER")
	times:EnableMouse(true)
	times:SetPoint("BOTTOM",minus,"TOP",0,5)
	times:SetScript("OnMouseUp",function() times:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." times " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	times:SetScript("OnEnter",function() times:SetBackdropColor(1,1,0) end)
	times:SetScript("OnLeave",function() times:SetBackdropColor(1,1,1) end)
	times:SetScript("OnMouseDown",function() times:SetBackdropColor(0,0,0) end)

	divide = CreateFrame("Frame",nil,CalcMainWindow)
	divide:SetHeight(25)
	divide:SetWidth(25)
	divide:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	divide:SetBackdropColor(1,1,1)
	dividetext = divide:CreateFontString(nil,nil,"GameFontHighlightLarge")
	dividetext:SetTextColor(0,0,1)
	dividetext:SetText("/")
	dividetext:SetPoint("CENTER",divide,"CENTER")
	divide:EnableMouse(true)
	divide:SetPoint("BOTTOM",times,"TOP",0,5)
	divide:SetScript("OnMouseUp",function() divide:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." divide " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	divide:SetScript("OnEnter",function() divide:SetBackdropColor(1,1,0) end)
	divide:SetScript("OnLeave",function() divide:SetBackdropColor(1,1,1) end)
	divide:SetScript("OnMouseDown",function() divide:SetBackdropColor(0,0,0) end)

	equals = CreateFrame("Frame",nil,CalcMainWindow)
	equals:SetHeight(25)
	equals:SetWidth(25)
	equals:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	equals:SetBackdropColor(1,1,1)
	equalstext = equals:CreateFontString(nil,nil,"GameFontHighlightLarge")
	equalstext:SetTextColor(0,0,1)
	equalstext:SetText("=")
	equalstext:SetPoint("CENTER",equals,"CENTER")
	equals:EnableMouse(true)
	equals:SetPoint("LEFT",plus,"RIGHT",5,0)
	equals:SetScript("OnMouseUp",function() equals:SetBackdropColor(1,1,1) calc(CalcEditBox:GetText()) CalcEditBox:SetText(CalcText) end)
	equals:SetScript("OnEnter",function() equals:SetBackdropColor(1,1,0) end)
	equals:SetScript("OnLeave",function() equals:SetBackdropColor(1,1,1) end)
	equals:SetScript("OnMouseDown",function() equals:SetBackdropColor(0,0,0) end)

	recip = CreateFrame("Frame",nil,CalcMainWindow)
	recip:SetHeight(25)
	recip:SetWidth(25)
	recip:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	recip:SetBackdropColor(1,1,1)
	reciptext = recip:CreateFontString(nil,nil,"GameFontHighlightLarge")
	reciptext:SetTextColor(0,0,1)
	reciptext:SetText("1/x")
	reciptext:SetPoint("CENTER",recip,"CENTER")
	recip:EnableMouse(true)
	recip:SetPoint("BOTTOM",equals,"TOP",0,5)
	recip:SetScript("OnMouseUp",function() recip:SetBackdropColor(1,1,1) local x,y=string.find(CalcEditBox:GetText(),"%p?%d*%p?%d*") CalcEditBox:SetText(1/tonumber(string.sub(CalcEditBox:GetText(),x,y))) end)
	recip:SetScript("OnEnter",function() recip:SetBackdropColor(1,1,0) end)
	recip:SetScript("OnLeave",function() recip:SetBackdropColor(1,1,1) end)
	recip:SetScript("OnMouseDown",function() recip:SetBackdropColor(0,0,0) end)

	power = CreateFrame("Frame",nil,CalcMainWindow)
	power:SetHeight(25)
	power:SetWidth(25)
	power:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	power:SetBackdropColor(1,1,1)
	powertext = power:CreateFontString(nil,nil,"GameFontHighlightLarge")
	powertext:SetTextColor(0,0,1)
	powertext:SetText("^")
	powertext:SetPoint("CENTER",power,"CENTER")
	power:EnableMouse(true)
	power:SetPoint("BOTTOM",recip,"TOP",0,5)
	power:SetScript("OnMouseUp",function() power:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." power " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	power:SetScript("OnEnter",function() power:SetBackdropColor(1,1,0) end)
	power:SetScript("OnLeave",function() power:SetBackdropColor(1,1,1) end)
	power:SetScript("OnMouseDown",function() power:SetBackdropColor(0,0,0) end)

	root = CreateFrame("Frame",nil,CalcMainWindow)
	root:SetHeight(25)
	root:SetWidth(25)
	root:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
	root:SetBackdropColor(1,1,1)
	roottext = root:CreateFontString(nil,nil,"GameFontHighlightLarge")
	roottext:SetTextColor(0,0,1)
	roottext:SetText("rt")
	roottext:SetPoint("CENTER",root,"CENTER")
	root:EnableMouse(true)
	root:SetPoint("BOTTOM",power,"TOP",0,5)
	root:SetScript("OnMouseUp",function() root:SetBackdropColor(1,1,1) CalcText = CalcEditBox:GetText().." root " CalcEditBox:SetText(CalcText) CalcEditBox:SetFocus() CalcEditBox:SetCursorPosition(9999999) end)
	root:SetScript("OnEnter",function() root:SetBackdropColor(1,1,0) end)
	root:SetScript("OnLeave",function() root:SetBackdropColor(1,1,1) end)
	root:SetScript("OnMouseDown",function() root:SetBackdropColor(0,0,0) end)
	
end

SlashCmdList["CALCULATOR"] = calc
SLASH_CALCULATOR1 = "/ca"